// ignore_for_file: unused_local_variable, non_constant_identifier_names

part of galaxeus_lib;

// void main() async {
//   WebSocketClient ws = WebSocketClient('ws://localhost:8080/ws', pingInterval: Duration(seconds: 2));
//   ws.connect();
//   ws.on("all", (Map update) {
//     print(update);
//   });
//   Timer.periodic(Duration(seconds: 2), (callback) {
//     ws.send("update", {"status": "helo world"});

//     print(ws.socket.closeReason);
//   });
// }

class WebSocketClient {
  late String url;
  late Iterable<String>? protocols;
  late Map<String, dynamic>? headers;
  late Duration? pingInterval;
  late bool isConnect = false;
  late EventEmitter event_emitter = EventEmitter();
  late List clients = [];
  WebSocketClient(this.url,
      {this.protocols,
      this.headers,
      this.pingInterval,
      EventEmitter? eventEmitter}) {
    if (eventEmitter != null) {
      event_emitter = eventEmitter;
    }
  }

  String createClientId() {
    String randomString = getRandom(15);

    return randomString;
  }

  Future<void> connect() async {
    late WebSocket socket;
    Listener listener = on("client_send", (update) {
      if (update is Map && update.containsKey("@type")) {
        if (isConnect) {
          try {
            socket.add(json.encode(update));
          } catch (e) {
            if (e is Map) {
              e["@type"] = "error";
              return event_emitter.emit("update", null, e);
            }
          }
        } else {
          return event_emitter.emit("update", null, {
            "@type": "clientSendPending",
            "message": "failed beacuse not connect websocket",
            "data": update
          });
        }
      }
    });
    while (true) {
      await Future.delayed(Duration(milliseconds: 500));
      if (isConnect == false) {
        try {
          socket = await WebSocket.connect(
            url,
            protocols: protocols,
            headers: headers,
          );
          socket.pingInterval = pingInterval;
          StreamSubscription scoketListen = socket.listen(
            (event) {
              if (event is String && event.isNotEmpty) {
                try {
                  return event_emitter.emit(
                    "update",
                    null,
                    json.decode(event),
                  );
                } catch (e) {
                  return;
                }
              }
            },
            onError: (a, b) {
              isConnect = false;
            },
            onDone: () async {
              isConnect = false;
              event_emitter.off(listener);
              await socket.done;
              await socket.close();
              event_emitter.emit("update", null, {
                "@type": "connection",
                "status": "disconnect",
              });
              await connect();
            },
            cancelOnError: true,
          );
          isConnect = true;
          return;
        } catch (e) {
          if (e is SocketException) {
            isConnect = false;
          }
        }
      }
    }
  }

  Listener on(String name, Function(dynamic update) callback) {
    return event_emitter.on(name, null, (ev, context) {
      if (ev.eventData != null) {
        callback(ev.eventData);
        return;
      }
    });
  }

  void clientSend(String name, [Map? data]) {
    data ??= {};
    if (isConnect) {
      return event_emitter.emit("client_send", null, {
        "@type": name,
        ...data,
      });
    } else {
      return event_emitter.emit("update", null, {
        "@type": "clientSendPending",
        "message": "failed beacuse not connect websocket",
        "data": {
          "@type": name,
          ...data,
        },
      });
    }
  }
}
